/********************************************************************-*-c-*-*\
*               *  Class examples for Advanced Porgramming                   *
*    #####      *  (!) Giovanni Squillero <giovanni.squillero@polito.it>     *
*   ######      *                                                            *
*   ###   \     *  Copying and distribution of this file, with or without    *
*    ##G  c\    *  modification, are permitted in any medium without royalty *
*    #     _\   *  provided this notice is preserved.                        *
*    |   _/     *  This file is offered as-is, without any warranty.         *
*    |  _/      *                                                            *
*               *  See: http://staff.polito.it/giovanni.squillero/dida.php   *
\****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "utils.h"
#include "hpfo.h"

/* local protos */
static void hpfoDebug(HPFO *H);

#define PARENT(X)	((X-1)/2)
#define LEFT(X)		(2*X+1)
#define RIGHT(X)	(2*X+2)

HPFO *hpfoCreate(int max)
{
	HPFO *H;
	H = (HPFO*)Malloc(sizeof (HPFO));
	H->heapSize = 0;
	H->maxSize = max;
	H->heap = (int*)Malloc(H->maxSize * sizeof (int));
	return H;
}

int hpfoPeek(HPFO *H)
{
	return H->heap[0];
}

void hpfoInsert(HPFO *H, int val)
{
	int pos;
	int tmp;

	pos = H->heapSize;
	H->heap[pos] = val;
	++H->heapSize;
	
	hpfoDebug(H);
	while(pos > 0 && H->heap[pos] > H->heap[PARENT(pos)]) {
		printf("Swap %d %d\n", pos, PARENT(pos));

		tmp = H->heap[pos];
		H->heap[pos] = H->heap[PARENT(pos)];
		H->heap[PARENT(pos)] = tmp;
		
		pos = PARENT(pos);

		hpfoDebug(H);
	}
}

static void hpfoDebug(HPFO *H)
{
	int t;
	
	for(t=0; t<H->heapSize; ++t)
		printf(" %d", H->heap[t]);
	printf("\n");
}

int hpfoExtract(HPFO *H);

